import React, { EffectCallback, DependencyList } from 'react';
import { DataSet } from 'choerodon-ui/pro';

declare const useMount: (fn: () => void) => void;

declare const useUnmount: (fn: () => void) => void;

declare const useEffectOnce: (mountFn?: (() => void) | undefined, unMountFn?: (() => void) | undefined) => void;

declare const useUpdate: () => () => void;

declare const useUpdateEffect: (effect: EffectCallback, deps?: DependencyList | undefined) => void;

declare const useDeepEffect: (effect: EffectCallback, deps: DependencyList) => void;

declare const useArray: <T>(initialValue?: T[]) => any[];

/**
 * 获取值集
 * @param code 值集编码
 * @param queryCode 值集的查询方法
 * @param isCache 是否缓存值集(默认false)
 */
declare const useCode: (code: string, queryCode: (arg0: string) => any, isCache?: boolean | undefined) => never[];

declare type DataSetFactory = () => DataSet;
declare const useDataSet: (dataSetFactory: DataSetFactory, deps?: DependencyList | undefined, cacheKey?: string | undefined) => DataSet;

declare const useDataSetIsSelected: (dataSet: DataSet) => boolean;

declare const useDataSetEvents: (dataSet: DataSet, eventNames: string | string[], handler: CallableFunction, options?: AddEventListenerOptions | undefined) => void;

declare const useTodayPoetry: (intervalTime?: number | undefined) => {
    content: string;
    tags: string[];
    origin: any;
    loading: boolean;
    allData: any;
    update: () => void;
};

/**
 *  store 和 dispatch 上下文分离
 * @param reducer
 * @param initialValue
 * @constructor
 */
declare const makeStore: (reducer: any, initialValue: any) => (React.FC<{}> | (() => any))[];

export { makeStore, useArray, useCode, useDataSet, useDataSetEvents, useDataSetIsSelected, useDeepEffect, useEffectOnce, useMount, useTodayPoetry, useUnmount, useUpdate, useUpdateEffect };
